#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _prefs_langs_xml_glade_xml[] =
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
"<glade-interface>"
"<!-- interface-requires gtk+ 2.8 -->"
"<!-- interface-naming-policy toplevel-contextual -->"
"<widget class=\"GtkWindow\" id=\"window5\">"
"<child>"
"<widget class=\"GtkVBox\" id=\"PrefsLangs\">"
"<property name=\"visible\">True</property>"
"<property name=\"border_width\">12</property>"
"<property name=\"spacing\">18</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox15\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label10\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">0</property>"
"<property name=\"label\" translatable=\"yes\">&lt;b&gt;Language-specific options&lt;/b&gt;</property>"
"<property name=\"use_markup\">True</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment8\">"
"<property name=\"visible\">True</property>"
"<property name=\"left_padding\">12</property>"
"<child>"
"<widget class=\"GtkVBox\" id=\"vbox16\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">6</property>"
"<child>"
"<widget class=\"GtkTable\" id=\"table\">"
"<property name=\"visible\">True</property>"
"<property name=\"n_rows\">4</property>"
"<property name=\"n_columns\">2</property>"
"<property name=\"column_spacing\">6</property>"
"<property name=\"row_spacing\">6</property>"
"<child>"
"<widget class=\"GtkEntry\" id=\"config\">"
"<property name=\"visible\">True</property>"
"<property name=\"tooltip\">strip: bool; add-newline:bool; use-tabs: bool; indent-width: integer; tab-width: integer</property>"
"<property name=\"activates_default\">True</property>"
"</widget>"
"<packing>"
"<property name=\"left_attach\">1</property>"
"<property name=\"right_attach\">2</property>"
"<property name=\"top_attach\">3</property>"
"<property name=\"bottom_attach\">4</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label11\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">1</property>"
"<property name=\"label\" translatable=\"yes\">Options:</property>"
"</widget>"
"<packing>"
"<property name=\"top_attach\">3</property>"
"<property name=\"bottom_attach\">4</property>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label_mimetypes\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">1</property>"
"<property name=\"label\" translatable=\"yes\">Mime types:</property>"
"</widget>"
"<packing>"
"<property name=\"top_attach\">1</property>"
"<property name=\"bottom_attach\">2</property>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label_extensions\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">1</property>"
"<property name=\"label\" translatable=\"yes\">Extensions:</property>"
"</widget>"
"<packing>"
"<property name=\"top_attach\">2</property>"
"<property name=\"bottom_attach\">3</property>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEntry\" id=\"mimetypes\">"
"<property name=\"visible\">True</property>"
"<property name=\"activates_default\">True</property>"
"</widget>"
"<packing>"
"<property name=\"left_attach\">1</property>"
"<property name=\"right_attach\">2</property>"
"<property name=\"top_attach\">1</property>"
"<property name=\"bottom_attach\">2</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkEntry\" id=\"extensions\">"
"<property name=\"visible\">True</property>"
"<property name=\"activates_default\">True</property>"
"</widget>"
"<packing>"
"<property name=\"left_attach\">1</property>"
"<property name=\"right_attach\">2</property>"
"<property name=\"top_attach\">2</property>"
"<property name=\"bottom_attach\">3</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"label768\">"
"<property name=\"visible\">True</property>"
"<property name=\"xalign\">1</property>"
"<property name=\"label\" translatable=\"yes\">Language:</property>"
"</widget>"
"<packing>"
"<property name=\"x_options\">GTK_FILL</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkComboBox\" id=\"lang_combo\">"
"<property name=\"visible\">True</property>"
"</widget>"
"<packing>"
"<property name=\"left_attach\">1</property>"
"<property name=\"right_attach\">2</property>"
"<property name=\"y_options\"></property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">0</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</glade-interface>"

;

typedef struct PrefsLangsXml PrefsLangsXml;

struct PrefsLangsXml {
    MooGladeXML *xml;

    GtkVBox *PrefsLangs;
    GtkTable *table;
    GtkEntry *config;
    GtkLabel *label_mimetypes;
    GtkLabel *label_extensions;
    GtkEntry *mimetypes;
    GtkEntry *extensions;
    GtkComboBox *lang_combo;

};

static void
_prefs_langs_xml_free (PrefsLangsXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static PrefsLangsXml *
prefs_langs_xml_get (gpointer widget)
{
    return (PrefsLangsXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_prefs_langs_xml_finish_build (PrefsLangsXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->PrefsLangs = (GtkVBox*) moo_glade_xml_get_widget (xml->xml, "PrefsLangs");
    g_return_val_if_fail (xml->PrefsLangs != NULL, FALSE);
    xml->table = (GtkTable*) moo_glade_xml_get_widget (xml->xml, "table");
    g_return_val_if_fail (xml->table != NULL, FALSE);
    xml->config = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "config");
    g_return_val_if_fail (xml->config != NULL, FALSE);
    xml->label_mimetypes = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "label_mimetypes");
    g_return_val_if_fail (xml->label_mimetypes != NULL, FALSE);
    xml->label_extensions = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "label_extensions");
    g_return_val_if_fail (xml->label_extensions != NULL, FALSE);
    xml->mimetypes = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "mimetypes");
    g_return_val_if_fail (xml->mimetypes != NULL, FALSE);
    xml->extensions = (GtkEntry*) moo_glade_xml_get_widget (xml->xml, "extensions");
    g_return_val_if_fail (xml->extensions != NULL, FALSE);
    xml->lang_combo = (GtkComboBox*) moo_glade_xml_get_widget (xml->xml, "lang_combo");
    g_return_val_if_fail (xml->lang_combo != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->PrefsLangs), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _prefs_langs_xml_free);
    return TRUE;
}

static gboolean
prefs_langs_xml_build (PrefsLangsXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _prefs_langs_xml_glade_xml, -1, "PrefsLangs", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_langs_xml_finish_build (xml);
}

static gboolean
prefs_langs_xml_fill (PrefsLangsXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _prefs_langs_xml_glade_xml, -1, "PrefsLangs", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _prefs_langs_xml_finish_build (xml);
}

static PrefsLangsXml *
prefs_langs_xml_new_empty (void)
{
    PrefsLangsXml *xml = g_new0 (PrefsLangsXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static PrefsLangsXml *
prefs_langs_xml_new (void)
{
    PrefsLangsXml *xml = prefs_langs_xml_new_empty ();
    if (!prefs_langs_xml_build (xml))
    {
        _prefs_langs_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static PrefsLangsXml *
prefs_langs_xml_new_with_root (GtkWidget *root)
{
    PrefsLangsXml *xml = prefs_langs_xml_new_empty ();
    if (!prefs_langs_xml_fill (xml, root))
    {
        _prefs_langs_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
