#include <mooutils/mooglade.h>
#include <mooutils/mooi18n.h>
#include <gtk/gtk.h>

static const char _editor_statusbar_xml_glade_xml[] =
"<?xml version=\"1.0\"?>"
"<glade-interface>"
"<widget class=\"GtkWindow\" id=\"window1\">"
"<child>"
"<widget class=\"GtkFrame\" id=\"EditorStatusbar\">"
"<property name=\"visible\">True</property>"
"<property name=\"label_xalign\">0</property>"
"<child>"
"<widget class=\"GtkAlignment\" id=\"alignment1\">"
"<property name=\"visible\">True</property>"
"<property name=\"left_padding\">6</property>"
"<property name=\"right_padding\">6</property>"
"<child>"
"<widget class=\"GtkHBox\" id=\"info\">"
"<property name=\"visible\">True</property>"
"<property name=\"spacing\">12</property>"
"<child>"
"<widget class=\"GtkLabel\" id=\"cursor\">"
"<property name=\"visible\">True</property>"
"<property name=\"label\">Line: 10  Col: 100</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"chars\">"
"<property name=\"visible\">True</property>"
"<property name=\"events\"></property>"
"<property name=\"label\">Chars: 10000</property>"
"</widget>"
"<packing>"
"<property name=\"position\">1</property>"
"</packing>"
"</child>"
"<child>"
"<widget class=\"GtkLabel\" id=\"insert\">"
"<property name=\"visible\">True</property>"
"<property name=\"label\">INS</property>"
"</widget>"
"<packing>"
"<property name=\"expand\">False</property>"
"<property name=\"fill\">False</property>"
"<property name=\"position\">2</property>"
"</packing>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</child>"
"</widget>"
"</glade-interface>"

;

typedef struct EditorStatusbarXml EditorStatusbarXml;

struct EditorStatusbarXml {
    MooGladeXML *xml;

    GtkFrame *EditorStatusbar;
    GtkHBox *info;
    GtkLabel *cursor;
    GtkLabel *chars;
    GtkLabel *insert;

};

static void
_editor_statusbar_xml_free (EditorStatusbarXml *xml)
{
    if (xml)
    {
        if (xml->xml)
            g_object_unref (xml->xml);
        g_free (xml);
    }
}

G_GNUC_UNUSED static EditorStatusbarXml *
editor_statusbar_xml_get (gpointer widget)
{
    return (EditorStatusbarXml*) g_object_get_data (G_OBJECT (widget), "moo-generated-glade-xml");
}

static gboolean
_editor_statusbar_xml_finish_build (EditorStatusbarXml *xml)
{
    g_return_val_if_fail(xml != NULL, FALSE);

    xml->EditorStatusbar = (GtkFrame*) moo_glade_xml_get_widget (xml->xml, "EditorStatusbar");
    g_return_val_if_fail (xml->EditorStatusbar != NULL, FALSE);
    xml->info = (GtkHBox*) moo_glade_xml_get_widget (xml->xml, "info");
    g_return_val_if_fail (xml->info != NULL, FALSE);
    xml->cursor = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "cursor");
    g_return_val_if_fail (xml->cursor != NULL, FALSE);
    xml->chars = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "chars");
    g_return_val_if_fail (xml->chars != NULL, FALSE);
    xml->insert = (GtkLabel*) moo_glade_xml_get_widget (xml->xml, "insert");
    g_return_val_if_fail (xml->insert != NULL, FALSE);

    g_object_set_data_full (G_OBJECT (xml->EditorStatusbar), "moo-generated-glade-xml",
                            xml, (GDestroyNotify) _editor_statusbar_xml_free);
    return TRUE;
}

static gboolean
editor_statusbar_xml_build (EditorStatusbarXml *xml)
{
    GError *error = NULL;
    if (!moo_glade_xml_parse_memory (xml->xml, _editor_statusbar_xml_glade_xml, -1, "EditorStatusbar", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _editor_statusbar_xml_finish_build (xml);
}

static gboolean
editor_statusbar_xml_fill (EditorStatusbarXml *xml, GtkWidget *root)
{
    GError *error = NULL;
    if (!moo_glade_xml_fill_widget (xml->xml, root, _editor_statusbar_xml_glade_xml, -1, "EditorStatusbar", &error))
    {
        g_critical ("Could not parse glade xml: %s", error->message);
        g_error_free (error);
        return FALSE;
    }
    return _editor_statusbar_xml_finish_build (xml);
}

static EditorStatusbarXml *
editor_statusbar_xml_new_empty (void)
{
    EditorStatusbarXml *xml = g_new0 (EditorStatusbarXml, 1);
    xml->xml = moo_glade_xml_new_empty (GETTEXT_PACKAGE);

    return xml;
}

G_GNUC_UNUSED static EditorStatusbarXml *
editor_statusbar_xml_new (void)
{
    EditorStatusbarXml *xml = editor_statusbar_xml_new_empty ();
    if (!editor_statusbar_xml_build (xml))
    {
        _editor_statusbar_xml_free (xml);
        xml = NULL;
    }
    return xml;
}

G_GNUC_UNUSED static EditorStatusbarXml *
editor_statusbar_xml_new_with_root (GtkWidget *root)
{
    EditorStatusbarXml *xml = editor_statusbar_xml_new_empty ();
    if (!editor_statusbar_xml_fill (xml, root))
    {
        _editor_statusbar_xml_free (xml);
        xml = NULL;
    }
    return xml;
}
